/* Example of new format for IO port bit definitions */
#if !defined(__cplusplus)

/* Data Register, Port A */
#    define PORTA       _SFR_IO8(0x1B)

/* Port A Data Register - PORTA */
#    define    PA7      _PORTBIT(PORTA,7)
#    define    PA6      _PORTBIT(PORTA,6)
#    define    PA5      _PORTBIT(PORTA,5)
#    define    PA4      _PORTBIT(PORTA,4)
#    define    PA3      _PORTBIT(PORTA,3)
#    define    PA2      _PORTBIT(PORTA,2)
#    define    PA1      _PORTBIT(PORTA,1)
#    define    PA0      _PORTBIT(PORTA,0)

/* 2-wire Serial Interface Control Register */
#    define TWCR        _SFR_MEM8(0x74)

/* Time Counter 1 Output Compare Register C */
#    define OCR1C       _SFR_MEM16(0x78)
#    define OCR1CL      _SFR_MEM8(0x78)

/* Timer/Counter 1 Control and Status Register */
#    define TCCR1B      _SFR_MEM8(0x2E)

/* Timer/Counter 3 Control Register B */
#    define TCCR3B      _SFR_MEM8(0x8A)

/* Timer/Counter Control and Status Register B (generic) */
#    define ICNC        _PORTBITG(7)
#    define ICES        _PORTBITG(6)
#    define WGMB3       _PORTBITG(4)
#    define WGMB2       _PORTBITG(3)
#    define CSB2        _PORTBITG(2)
#    define CSB1        _PORTBITG(1)
#    define CSB0        _PORTBITG(0)

/* Timer/Counter 1 Control and Status Register B - TCCR1B */
#    define ICNC1       _PORTBIT(TCCR1B,7)
#    define ICES1       _PORTBIT(TCCR1B,6)
#    define WGM13       _PORTBIT(TCCR1B,4)
#    define WGM12       _PORTBIT(TCCR1B,3)
#    define CS12        _PORTBIT(TCCR1B,2)
#    define CS11        _PORTBIT(TCCR1B,1)
#    define CS10        _PORTBIT(TCCR1B,0)

/* Timer/Counter 3 Control and Status Register B - TCCR3B */
#    define ICNC3       _PORTBIT(TCCR3B,7)
#    define ICES3       _PORTBIT(TCCR3B,6)
#    define WGM33       _PORTBIT(TCCR3B,4)
#    define WGM32       _PORTBIT(TCCR3B,3)
#    define CS32        _PORTBIT(TCCR3B,2)
#    define CS31        _PORTBIT(TCCR3B,1)
#    define CS30        _PORTBIT(TCCR3B,0)

/* 2-wire Control Register - TWCR */
#    define TWINT       _PORTBIT(TWCR,7)
#    define TWEA        _PORTBIT(TWCR,6)
#    define TWSTA       _PORTBIT(TWCR,5)
#    define TWSTO       _PORTBIT(TWCR,4)
#    define TWWC        _PORTBIT(TWCR,3)
#    define TWEN        _PORTBIT(TWCR,2)
#    define TWIE        _PORTBIT(TWCR,0)

#else

/* Data Register, Port A */
_SFR_IO8_DECLARE(PORTA,0x1B)

/* Port A Data Register - PORTA */
_PORTBIT_DECLARE(PA7,PORTA,7)
_PORTBIT_DECLARE(PA6,PORTA,6)
_PORTBIT_DECLARE(PA5,PORTA,5)
_PORTBIT_DECLARE(PA4,PORTA,4)
_PORTBIT_DECLARE(PA3,PORTA,3)
_PORTBIT_DECLARE(PA2,PORTA,2)
_PORTBIT_DECLARE(PA1,PORTA,1)
_PORTBIT_DECLARE(PA0,PORTA,0)

/* 2-wire Serial Interface Control Register */
_SFR_MEM8_DECLARE(TWCR,0x74)

/* Time Counter 1 Output Compare Register C */
_SFR_MEM16_DECLARE(OCR1C,0x78)
_SFR_MEM8_DECLARE(OCR1CL,0x78)

/* Timer/Counter 1 Control and Status Register */
_SFR_MEM8_DECLARE(TCCR1B,0x2E)

/* Timer/Counter 3 Control Register B */
_SFR_MEM8_DECLARE(TCCR3B,0x8A)

/* Timer/Counter Control and Status Register B (generic) */
_PORTBITG_DECLARE(ICNC,7)
_PORTBITG_DECLARE(ICES,6)
_PORTBITG_DECLARE(WGMB3,4)
_PORTBITG_DECLARE(WGMB2,3)
_PORTBITG_DECLARE(CSB2,2)
_PORTBITG_DECLARE(CSB1,1)
_PORTBITG_DECLARE(CSB0,0)

/* Timer/Counter 1 Control and Status Register B - TCCR1B */
_PORTBIT_DECLARE(ICNC1,TCCR1B,7)
_PORTBIT_DECLARE(ICES1,TCCR1B,6)
_PORTBIT_DECLARE(WGM13,TCCR1B,4)
_PORTBIT_DECLARE(WGM12,TCCR1B,3)
_PORTBIT_DECLARE(CS12,TCCR1B,2)
_PORTBIT_DECLARE(CS11,TCCR1B,1)
_PORTBIT_DECLARE(CS10,TCCR1B,0)

/* Timer/Counter 3 Control and Status Register B - TCCR3B */
_PORTBIT_DECLARE(ICNC3,TCCR3B,7)
_PORTBIT_DECLARE(ICES3,TCCR3B,6)
_PORTBIT_DECLARE(WGM33,TCCR3B,4)
_PORTBIT_DECLARE(WGM32,TCCR3B,3)
_PORTBIT_DECLARE(CS32,TCCR3B,2)
_PORTBIT_DECLARE(CS31,TCCR3B,1)
_PORTBIT_DECLARE(CS30,TCCR3B,0)

/* 2-wire Control Register - TWCR */
_PORTBIT_DECLARE(TWINT,TWCR,7)
_PORTBIT_DECLARE(TWEA,TWCR,6)
_PORTBIT_DECLARE(TWSTA,TWCR,5)
_PORTBIT_DECLARE(TWSTO,TWCR,4)
_PORTBIT_DECLARE(TWWC,TWCR,3)
_PORTBIT_DECLARE(TWEN,TWCR,2)
_PORTBIT_DECLARE(TWIE,TWCR,0)

#endif
